from PyQt5.QtCore import QVariant,QObject,pyqtSlot
from PyQt5.QtQml import QJSValue

class JSFunction:
    def __init__(self,refill : QVariant=None,name:str=None):

        self._input = refill
        self._name = name
    def insert(self,refill,name=None):
        self._input = refill
        self._name = name

    def __call__(self, *args, **kwargs):
        if(self._input):
            list=[]
            for arg in args:
                list.append(QJSValue(arg))

            if(list):
                self._input.call(list)
            else:
                self._input.call()





class BaseNotifications(QObject):
    'Allows to call javascript functions from Python'

    def __init__(self, parent = None):
        super().__init__(parent)

        self._callBacks = {}

    @pyqtSlot(str, 'QVariant')
    def setFunction(self, functionName: str, function: QVariant):
        self._callBacks.update({functionName: JSFunction(refill=function, name=functionName)})

    def getCallback(self, functionName) -> JSFunction:
        return self._callBacks.get(functionName, JSFunction())
