
from PyQt5.QtCore import Qt, QCoreApplication, pyqtSlot,pyqtProperty
from UM.Application import Application

from UM.Qt.ListModel import ListModel
from .NozzlesModel import NozzlesModel

class MaterialsModel(ListModel):
    MaterialNameRole = Qt.UserRole+1

    def __init__(self,parent=None):
        if Application.getInstance()._materials != None:
            raise ValueError("Duplicate singleton creation of MaterialsModel")
        Application.getInstance()._materials= self

        super().__init__(parent)
        self._printerTree = Application.getInstance()._printerTree
        self.addRoleName(self.MaterialNameRole, "name")
        self._update()

    def _update(self):
        items=[]
        nozzle = MaterialsModel.getInstance().__Nozzle

        if(not len(nozzle) == 0):
            printer = NozzlesModel.getInstance().getPrinter()

            node = self._printerTree.getMaterialsNode(printer,nozzle)
            nozzles = node.getCurrentNode()[2]


            for i in nozzles:
                item = {"name": i}
                items.append(item)

        self.setItems(items)


    def getNozzle(self):
        return MaterialsModel.getInstance().__Nozzle

    __Nozzle=""


    @classmethod
    def getInstance(cls):
        if  Application.getInstance()._materials is None:
            Application.getInstance()._materials= cls()

        return Application.getInstance()._materials

    @staticmethod
    def onNozzleChanged(newNozzle):
        MaterialsModel.getInstance().__Nozzle=newNozzle
        MaterialsModel.getInstance()._update()


def CreateMaterialsModel(engine, script_engine):
    return MaterialsModel.getInstance()