from PyQt5.QtCore import Qt, QCoreApplication, pyqtSlot,pyqtProperty
from UM.Application import Application

from UM.Qt.ListModel import ListModel

class NozzlesModel(ListModel):
    NozzleNameRole = Qt.UserRole+1

    def __init__(self,parent=None):

        if Application.getInstance()._nozzles != None:
            raise ValueError("Duplicate singleton creation of Nozzlesmodel")
        Application.getInstance()._nozzles= self

        super().__init__(parent)
        self._printerTree = Application.getInstance()._printerTree
        self.addRoleName(self.NozzleNameRole, "name")
        self._update()



    def __del__(self):
        pass
        # NozzlesModel.__instances.remove(self)

    def _update(self):
        items=[]
        printer = NozzlesModel.getInstance().__Printer

        if(not len(printer) == 0):
            node = self._printerTree.getNozzlesNode(printer)
            nozzles = node.getCurrentNode()[2]


            for i in nozzles:
                item = {"name": i}
                items.append(item)

        self.setItems(items)

    def getPrinter(self):
        return NozzlesModel.getInstance().__Printer;

    __Printer=""


    @classmethod
    def getInstance(cls):
        if  Application.getInstance()._nozzles is None:
            Application.getInstance()._nozzles= cls()


        return Application.getInstance()._nozzles

    @staticmethod
    def onPrinterChanged(newPrinter):
        NozzlesModel.getInstance().__Printer=newPrinter
        NozzlesModel.getInstance()._update()


def CreateNozzlesModel(engine, script_engine):
    return NozzlesModel.getInstance()