# Copyright (c) 2015 Ultimaker B.V.
# Uranium is released under the terms of the AGPLv3 or higher.


from UM.Operations.ScaleOperation import ScaleOperation

from UM.Operations.Operation import Operation

from UM.Scene.SceneNode import SceneNode
from UM.Math.Vector import Vector


class GenceScaleOperation(ScaleOperation):

    def __init__(self, node, scale, set_scale = False, add_scale = False, relative_scale = False, scale_around_point = Vector(0, 0, 0), snap = False,mergeKey=None):
        super().__init__(node, scale, set_scale, add_scale, relative_scale, scale_around_point, snap)
        self._mergeKey=mergeKey

    def mergeWith(self, other):
        if type(other) is not GenceScaleOperation:
            return False
        if other._node != self._node: #Must be scaling the same node.
            return False
        if other._set_scale and not self._set_scale: #Must be the same type of scaling.
            return False
        if other._add_scale and not self._add_scale:
            return False
        if other._relative_scale and not self._relative_scale:
            return False

        if other._mergeKey!= self._mergeKey:
            print(other._mergeKey,self._mergeKey)
            return False

        op = GenceScaleOperation(node=self._node, scale=self._node.getScale(),mergeKey=self._mergeKey)
        op._old_transformation = other._old_transformation #Use the oldest transformation of the two.
        return op
