import QtQuick 2.0
import QtQuick.Controls 1.4
import UM 1.2 as UM
import Gence 1.0 as Gence
import "../../../JS/toolbox.js" as Toolbox



MoveButtonContentForm {

    id:mvcontent
    property bool visibility:false;
    property double jump: 1.0;
    property double xPos: Gence.Notifications.xPos


    Connections
    {
        target:mvcontent
        onXPosChanged:
        {
            console.log("x Pos changed")
        }
    }

    Timer {
        id:timer
        interval: 20; running: true; repeat: false
    }

    Connections
    {
        target: timer
        onTriggered: updateSpinBoxes()
    }

//    Connections
//    {
//        target:UM.Selection
//        enabled: Gence.Notifications.appState === Gence.Notifications.NODE_LOADED
//        onHasSelectionChanged:
//        {
//            if(UM.Selection.hasSelection)
//            {
//                stopSignals()
//                updateSpinBoxes()
//                startSignals()

//                console.log("Update")

//            }
//        }
//    }



    Connections
    {
        id: onNodeMovedConnection
        target: Gence.Actions.modelWasMoved
        onTriggered:
        {
            stopSignals()
            updateSpinBoxes();
            startSignals()
        }

    }

    onVisibleChanged: {
        if(visible)
        {
            onNodeMovedConnection.target=Gence.Actions.modelWasMoved
            timer.start()
        }else
        {
            onNodeMovedConnection.target=null;
        }

    }

    function stopSignals()
    {
        xSpinBox.textField.onTextChanged.enabled = false;
        ySpinBox.textField.onTextChanged.enabled = false;
        zSpinBox.textField.onTextChanged.enabled = false;
    }
    function startSignals()
    {
        xSpinBox.textField.onTextChanged.enabled = true;
        ySpinBox.textField.onTextChanged.enabled = true;
        zSpinBox.textField.onTextChanged.enabled = true;
    }

    function updateSpinBoxes()
    {
        var value_x = UM.ActiveTool.properties.getValue("X")
        var value_y = UM.ActiveTool.properties.getValue("Y")
        var value_z = UM.ActiveTool.properties.getValue("Z")

        if(!isNaN(value_x) && !isNaN(value_y) && !isNaN(value_z)){
            xSpinBox.textField.text = Toolbox.round(value_x, x_precision)
            ySpinBox.textField.text = Toolbox.round(value_y, y_precision)
            zSpinBox.textField.text = Toolbox.round(value_z, z_precision)
        }
    }

    Connections {

        target: placeButtonAction
        onClicked: UM.ActiveTool.setProperty("Z", 0)
    }

    Connections {
        target: resetMoveButtonAction
        onClicked:{
            UM.ActiveTool.triggerAction("resetMove")
        }
    }

    Connections
    {
        target:xSpinBox.onValueChanged
        onTriggered: UM.ActiveTool.setProperty("X", Toolbox.round(xSpinBox.value, x_precision))
    }
    Connections
    {
        target:ySpinBox.onValueChanged
        onTriggered: UM.ActiveTool.setProperty("Y", Toolbox.round(ySpinBox.value, y_precision))
    }
    Connections
    {
        target:zSpinBox.onValueChanged
        onTriggered:UM.ActiveTool.setProperty("Z", Toolbox.round(zSpinBox.value, z_precision))
    }


    Connections {
        target: xSpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("X");
            UM.ActiveTool.setProperty("X", Toolbox.round(value + jump, x_precision));
        }
    }
    Connections {
        target: xSpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("X");
            UM.ActiveTool.setProperty("X", Toolbox.round(value - jump, x_precision));
        }
    }


    Connections {
        target: ySpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("Y");
            UM.ActiveTool.setProperty("Y",Toolbox.round(value + jump, y_precision));
        }
    }
    Connections {
        target: ySpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("Y");
            UM.ActiveTool.setProperty("Y",Toolbox.round(value - jump, y_precision));
        }
    }

    Connections {
        target: zSpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("Z");
            UM.ActiveTool.setProperty("Z", Toolbox.round(value + jump, z_precision));
        }
    }

    Connections {
        target: zSpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("Z");
            UM.ActiveTool.setProperty("Z", Toolbox.round(value - jump, z_precision));
        }
    }

}
