import QtQuick 2.4
import QtQuick.Dialogs 1.2
import UM 1.3 as UM

import Gence 1.0 as Gence
import Settings 1.0 as Settings
import "../../layout/content"

ProfileButtonContentForm {
    onList1HeightChanged: changeHeightMod()
    onList2HeightChanged: changeHeightMod()

    // TODO zmienić na nozzle
    // Connections {
    //     target: right_menu_manager
    //     onChangeProfileMenu: {
    //         list1.list.changeCurrentText(value)
    //     }
    // }

    Connections {
        target: right_menu_manager
        onChangeNozzleMenu: {
            list1.list.changeCurrentText(value)
        }
    }

    Connections {
        target: right_menu_manager
        onChangeMaterialMenu: {
            list2.list.changeCurrentText(value)
        }
    }

    Connections {
        target: rightMenuContent
        onDefaultProfileLoaded:
        {
            list2.list.enableList()
        }
    }

    Connections
    {
        target: CuraApplication
        onCustomProfileLoaded:
        {
            list1.list.changeCurrentText("Custom")
            list2.list.changeCurrentText("Custom")
            list2.list.disableList()
            resetLists()
        }
    }

    Connections
    {
        target: Settings.Notifications

        onManualProfileLoaded: {
            list2.list.enableList()
        }
    }

    function changeHeightMod() {
        menuHeightMod = list1Height + list2Height + loadCustomButtonHeight + editCustomButtonHeight + layout.spacing * 3
    }

    function resetLists() {
        list1.currentIndex = -1
        list2.currentIndex = -1
    }

    // TODO things here:
    // FileDialog
    // {
    //     id: openFolderDialog
    //     title: "Open profile folder"
    //     selectFolder: true
    //     selectMultiple: false
    //     modality: UM.Application.platform == "linux" ? Qt.NonModal : Qt.WindowModal
    //     folder: Settings.Notifications.get_profiles_folder()
    //     onAccepted: {
    //         firstEnter = true
    //         profile_path = fileUrl
    //         Gence.ModelsHolder.updateOtherProfilesFromPath(fileUrl)
    //     }
    // }
}
