import QtQuick 2.4
import UM 1.3 as UM
import Gence 1.0 as Gence
import QtQuick.Controls 1.4
import "../../../JS/toolbox.js" as Toolbox

RotateButtonContentForm {

    Timer {
       id:timer
       interval: 20; running: true; repeat: false

    }

    Connections
    {
        target: timer
        onTriggered: updateSpinBoxes()
    }

    Connections
    {
        id: onNodeRotated
        target: Gence.Actions.modelWasMoved
        onTriggered:
        {
            stopSignals();
            updateSpinBoxes();
            startSignals();
        }
    }

    onVisibleChanged: {
        if(visible)
        {
            onNodeRotated.target=Gence.Actions.modelWasMoved;
            timer.start()


        }
        else
        {
            onNodeRotated.target=null;
        }
    }

    function stopSignals()
    {
        yzSpinBox.textField.onTextChanged.enabled = false;
        xzSpinBox.textField.onTextChanged.enabled = false;
        xySpinBox.textField.onTextChanged.enabled = false;
    }

    function startSignals()
    {
        yzSpinBox.textField.onTextChanged.enabled = true;
        xzSpinBox.textField.onTextChanged.enabled = true;
        xySpinBox.textField.onTextChanged.enabled = true;
    }

    function updateSpinBoxes()
    {
        yzSpinBox.textField.text=Toolbox.round(UM.ActiveTool.properties.getValue("RotationX"), yzSpinBox.precision);
        xzSpinBox.textField.text=Toolbox.round(UM.ActiveTool.properties.getValue("RotationZ"), xzSpinBox.precision);
        xySpinBox.textField.text=Toolbox.round(UM.ActiveTool.properties.getValue("RotationY"), xySpinBox.precision);
    }

    Connections
    {
        target: yzSpinBox.onValueChanged
        onTriggered: UM.ActiveTool.setProperty("RotationX", Toolbox.round(yzSpinBox.value, yzSpinBox.precision));
    }

    Connections
    {
        target: xzSpinBox.onValueChanged
        onTriggered:UM.ActiveTool.setProperty("RotationZ", Toolbox.round(xzSpinBox.value, xzSpinBox.precision));
    }
    Connections
    {
        target: xySpinBox.onValueChanged
        onTriggered:UM.ActiveTool.setProperty("RotationY", Toolbox.round(xySpinBox.value, xySpinBox.precision));
    }

//    yzSpinBox.onValueChanged: UM.ActiveTool.setProperty("RotationX",yzSpinBox.value);
//    xzSpinBox.onValueChanged: UM.ActiveTool.setProperty("RotationZ",xzSpinBox.value);
//    xySpinBox.onValueChanged: UM.ActiveTool.setProperty("RotationY",xySpinBox.value);

    Connections
    {
        id: yzPLUS
        target: yzSpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationX");
            UM.ActiveTool.setProperty("RotationX",Toolbox.round(value+yzSpinBox.singleStep, yzSpinBox.precision));
        }
    }
    Connections
    {
        id: yzMinus
        target: yzSpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationX");
            UM.ActiveTool.setProperty("RotationX", Toolbox.round(value-yzSpinBox.singleStep, yzSpinBox.precision));
        }
    }
    Connections
    {
        id:xzPlus
        target: xzSpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationZ");
            UM.ActiveTool.setProperty("RotationZ", Toolbox.round(value+xzSpinBox.singleStep, xzSpinBox.precision));
        }
    }
    Connections
    {
        id:xzMinus
        target: xzSpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationZ");
            UM.ActiveTool.setProperty("RotationZ", Toolbox.round(value-xzSpinBox.singleStep, xzSpinBox.precision));
        }
    }
    Connections
    {
        id:xyPlus
        target: xySpinBox.plusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationY");
            UM.ActiveTool.setProperty("RotationY", Toolbox.round(value+xySpinBox.singleStep, xySpinBox.precision));
        }
    }
    Connections
    {
        id:xyMinus
        target: xySpinBox.minusAction
        onClicked:
        {
            var value = UM.ActiveTool.properties.getValue("RotationY");
            UM.ActiveTool.setProperty("RotationY", Toolbox.round(value-xySpinBox.singleStep, xySpinBox.precision));
        }
    }
    Connections
    {
        target: resetAction
        onTriggered: UM.ActiveTool.triggerAction("resetRotation");
    }
}
