import QtQuick 2.4
import QtQuick.Layouts 1.1


import "../../buttons"

import Gence 1.0 as Gence
import Settings 1.0 as Settings

Item {
    property alias layoutHeight: layout.height
    property bool firstModelLoad: true
    property alias qualitiesHeight: qualitiesLV.contentHeight

    ColumnLayout {
        id: layout
        anchors.fill: parent
        spacing: parent.width * 0.05
        ListView {
            id:qualitiesLV
            Layout.fillHeight: true
            Layout.fillWidth: true
            spacing: parent.width * 0.05
            interactive: false

            onCurrentItemChanged:
            {
                currentOption = currentItem.menuButtonText
                Settings.Notifications.quality = currentItem.menuButtonText
            }

            onCountChanged:
            {
                if(count===0 && !firstModelLoad) {
                    currentOption="Empty"
                    Settings.Notifications.quality = ""
                } else{
                    currentIndex=0
                }

                if(firstModelLoad)
                    firstModelLoad = false
            }


            model:Gence.ModelsHolder.qualities

            delegate: MenuOptionButton {
                menuButtonText: name
            }
        }

        }

}
