import QtQuick 2.0
//import QtQuick.Controls 2.0
import QtQuick.Layouts 1.1

import "../../singletons"
import "../../tweaks"

Item {
    id: popup
    property bool autoclose: false
    property string helpText: ""
    property string helpImageSource: ""

    property alias menu: menu
    property alias popup: popup
    property alias contentLoader: contentLoader
    property alias item: contentLoader.item
//    anchors.fill: parent
    visible: false

    x: buttonWidth
    //implicitWidth: parent.width
    width: menuWidth
    //TODO: set dynamic height
    height: menuHeight

    Rectangle {
        id: menu
        anchors.fill: parent
        border.width: Globals.menuBorderWidth
        border.color: Colors.buttonMenuBorder
        color: Colors.buttonMenuBackground

        MouseArea {
            anchors.fill: parent
        }

        ColumnLayout {
            anchors.fill: parent
            spacing: 0

            Rectangle {
                Layout.preferredHeight: buttonTextBackgroundHeight
                Layout.fillWidth: true
                color: Colors.buttonTextBackground

                Text {
                    anchors.centerIn: parent
                    font.pixelSize: Globals.fontPixelSize
                    font.capitalization: Font.AllUppercase
                    font.family: Fonts.boxed

                    color: Colors.buttonText
                    text: buttonText
                }
            }

            Rectangle {
                Layout.fillWidth: true
                Layout.preferredHeight: Globals.decoratorHeight
                color: Colors.buttonDecorator
            }

            Loader {
                id: contentLoader
                Layout.fillHeight: true
                Layout.fillWidth: true
                Layout.margins: Globals.menuMargin
            }
        }
    }

    ButtonTweaks{
        z: -1
        hoverIndicatorEnabled: false
        helpText: popup.helpText
        helpImageSource: popup.helpImageSource
    }
}
