import QtQuick 2.4
import SI 1.0 as SI

CameraCubeForm {

    property bool topSideActive: false
    property bool leftSideActive: false
    property bool rightSideActive: true
    property bool dot1Active: false
    property bool dot2Active: false
    property bool dot3Active: false
    property bool dot4Active: false
    property bool dot5Active: false
    property bool dot6Active: false
    property bool dot7Active: false

    //centers control
    cameraCube.transform: Translate { x: parent.width/2 }

    topSide.transform: [
        Rotation {origin.x: 0; origin.y: 0; angle: 45 },
        Scale {yScale: Math.tan(Math.PI/6)}
    ]

    rightSide.transform: [
        Rotation {origin.x: 0; origin.y: 0; angle: 45 },
        Scale { yScale: Math.tan(Math.PI/6) },
        Rotation {origin.x: 0; origin.y: 0;  angle: -60 }
    ]

    leftSide.transform: [
        Rotation { origin.x: 0; origin.y: 0;  angle: -45 },
        Scale { yScale: Math.tan(Math.PI/6) },
        Rotation { origin.x: 0; origin.y: 0;  angle: 60 }
    ]

    Connections {
        target: rightSideMouseArea
        onClicked: onRightSideClicked()
    }

    Connections {
        target: leftSideMouseArea
        onClicked: onLeftSideClicked()
    }

    Connections {
        target: topSideMouseArea
        onClicked: onTopSideClicked()
    }

    Connections {
        target: dot1MouseArea
        onClicked: onRightBackUpperClicked()
    }

    Connections {
        target: dot2MouseArea
        onClicked: onLeftBackUpperClicked()
    }

    Connections {
        target: dot3MouseArea
        onClicked: onRightFrontUpperClicked()
    }

    Connections {
        target: dot4MouseArea
        onClicked: onDot4Clicked()
    }

    Connections {
        target: dot5MouseArea
        onClicked: onDot5Clicked()
    }

    Connections {
        target: dot6MouseArea
        onClicked: onDot6Clicked()
    }

    Connections {
        target: dot7MouseArea
        onClicked: onDot7Clicked()
    }

    function resetState(){
        topSideActive = false
        leftSideActive = false
        rightSideActive = false
        dot1Active = false
        dot2Active = false
        dot3Active = false
        dot4Active = false
        dot5Active = false
        dot6Active = false
        dot7Active = false
    }

    function onTopSideClicked(){
        SI.CameraOperator.showFrom("top")
        resetState()
        topSideActive = true
    }

    function onRightSideClicked(){
        SI.CameraOperator.showFrom("front")
        resetState()
        rightSideActive = true
    }

    function onLeftSideClicked(){
         SI.CameraOperator.showFrom("left")
        resetState()
        leftSideActive = true
    }

    function onRightBackUpperClicked(){

        SI.CameraOperator.showFrom("rightBackUpper")

        resetState()
        dot1Active = true
    }

    function onLeftBackUpperClicked(){
        SI.CameraOperator.showFrom("leftBackUpper")

        resetState()
        dot2Active = true
    }

    function onRightFrontUpperClicked(){
        SI.CameraOperator.showFrom("rightFrontUpper")
        console.log("Right front upper")
        resetState()
        dot3Active = true
    }

    function onDot4Clicked(){
        SI.CameraOperator.showFrom("leftFrontUpper")
        resetState()
        dot4Active = true
    }

    function onDot5Clicked(){
        SI.CameraOperator.showFrom("leftBackBottom")
        resetState()
        dot5Active = true
    }

    function onDot6Clicked(){
        SI.CameraOperator.showFrom("rightFrontBottom")
        resetState()
        dot6Active = true
    }

    function onDot7Clicked(){
        SI.CameraOperator.showFrom("leftFrontBottom")
        resetState()
        dot7Active = true
    }
}
