import QtQuick 2.4
import QtQuick.Controls 2.0
import QtQuick.Controls.Styles 1.4
import QtQuick.Layouts 1.1

import "../singletons"
Item {
    property alias labelText: label.text
    property alias checkBox: checkBox
    property alias value: checkBox.checked

    Layout.fillWidth: true
    Layout.preferredHeight: Math.floor(Globals.fontPixelSize * 2.09)
    Layout.alignment: Qt.AlignCenter

    Text {
        id: label
        text: "checkbox"
        anchors.verticalCenter: parent.verticalCenter
        anchors.verticalCenterOffset: 2
        color: Colors.spinBoxLabelText
        font.pixelSize: Globals.fontPixelSize
        font.family: Fonts.boxed
    }


    CheckBox {
        id: checkBox
        height: parent.height
        anchors.right: parent.right
        anchors.verticalCenter: parent.verticalCenter

        indicator: Rectangle {
            id: box
            anchors.right: parent.right
            width: parent.height
            height: width
            border.color: Colors.customSettingsEditBorder

            Text {
                id: line
                font.pixelSize: Globals.fontPixelSize
                // font.family: Fonts.boxed
                color: Colors.customSettingsText
                text: "✔"
                anchors.centerIn: parent
                visible: checkBox.checked
            }
        }
    }
}