import QtQuick 2.4
import QtQuick.Layouts 1.1

import "../singletons"
import "../tweaks"

RowLayout {
    id: labeledListLayout
    property bool updateButtonOption: false
    property string helpText: ""
    property alias scrollable: list.scrollable
    property alias labelText: text.text
    property alias listHeight: list.listHeight
    property alias listWidth: list.listWidth
    property alias listModel: list.listModel
    property alias listOpened: list.listOpened
    property alias selected: list.selected
    property alias currentIndex : list.currentIndex
    property alias list: list
    property alias emptyListText: list.defaultListText

    Text {
        id: text
        text: "Label:"
        Layout.preferredWidth: contentWidth > Globals.buttonHeight * 0.7 ? contentWidth : Globals.buttonHeight * 0.7
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.topMargin: list.background.height * 0.25
        color: Colors.listText
        horizontalAlignment: Text.AlignRight

        font.pixelSize: Globals.fontPixelSize
        font.family: Fonts.boxed

        ButtonTweaks {
            z: -1
            hoverIndicatorEnabled: false
            helpText: labeledListLayout.helpText
        }
    }

    RetractableList {
        id: list
        ButtonTweaks {
            visible: !list.listOpened
            z: -1
            hoverIndicatorEnabled: false
            helpText: labeledListLayout.helpText
        }
    }
}