import QtQuick 2.4
import Gence 1.0 as Gence

import "../singletons"

RetractableListElementForm {
    // rised on element clicked
    signal elementClicked ();

    Connections {
        target    : elementMouseArea
        onEntered : onMouseEnter()
        onExited  : onMouseExit()
        onClicked : onMouseClicked()
    }

    function onMouseEnter() {
        elementBackground.color = Colors.listHighlightedBackground
        elementText.color = Colors.listHighlightedText
    }

    function onMouseExit() {
        elementBackground.color = Colors.listBackground
        elementText.color = Colors.listText
    }

    function onMouseClicked() {
        elementClicked ()  // notify
        if(list.currentIndex == index){
            list.onCurrentItemChanged()
        } else{
            list.currentIndex = index
        }
        if(updateOption){
            currentOption = text
        }
    }
}
