import QtQuick 2.4

import "../singletons"

Item {
    property bool scrollableElement: false
    property alias text: text.text
    property alias elementMouseArea: mouseArea
    property alias elementBackground: rectangle
    property alias elementText: text

    property bool updateOption: false

    width: parent.width
    anchors.horizontalCenter: parent.horizontalCenter
    height: text.height * 2

    Rectangle {
        id: rectangle
        anchors.fill: parent
        border.color: Colors.listBorder
        border.width: 1

        Text {
            id: text
            width: parent.width * (scrollableElement ? 0.85 : 0.92)
            anchors.verticalCenter: parent.verticalCenter
            anchors.left: parent.left
            anchors.leftMargin: parent.width * 0.04
            anchors.rightMargin: parent.width * 0.04
            text: "tesText"
            color: Colors.listText

            font.pixelSize: Globals.fontPixelSize
            font.family: Fonts.boxed
            elide: Text.ElideMiddle
        }
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent
        hoverEnabled: true
    }
}
