import QtQuick 2.4

import "../../singletons"

AboutForm {
    Component.onCompleted: {
        widthFactor = 4.65
        heightFactor = 4.6
        loaderMarginsFactor = 0.04
    }

    Connections {
        target: Globals.modalWindow
        onOpened: opened()
    }

    Connections {
        target: checkBox
        onCheckedChanged: Printer.setAutoUpdate(checkBox.checked)
    }

    Connections {
        target: updateStatus
        onVisibleChanged: {
            if (updateStatus.visible === true){
                expandHeightBy(updateStatus.height + spacingSize * 2)
            } else {
                heightFactor = 4.6
            }
        }
    }

    function opened() {
        updateStatus.visible = false
        version = Printer.appVersion
        checkBox.checked = Printer.isAutoUpdateEnabled
        setAdditionalDBsString()
    }

    function setAdditionalDBsString(){
        var dbStrings = []

        if(Printer.testProfilesEnabled) {
            dbStrings.push("Test")
        }
        if(Printer.draftProfilesEnabled) {
            dbStrings.push("Draft")
        }
        var dbStringsLen = dbStrings.length

        var dbCatString = ""
        if (dbStrings !== undefined && dbStringsLen > 0) {
            dbCatString += ", "

            for(var i = 0; i < dbStringsLen; i++){
                dbCatString += dbStrings[i]
                if(i < dbStringsLen - 1){
                    dbCatString += ", "
                }
            }
        }

        additionalDBs = dbCatString
    }
}