// Copyright (c) 2015 Ultimaker B.V.
// Uranium is released under the terms of the AGPLv3 or higher.

import QtQuick 2.2
import QtQuick.Controls 1.1

import "../../singletons"

CustomTab {
    text: definition.label
    setWidth: enabled ? tabWidth : 0
    setHeight: tabHeight

    Connections {
        target: settingView
        onCategoryTabClicked: {
            setChecked(tabName)
            expandTab()
        }
    }

    mouseArea.onClicked: {
        forceActiveFocus()
        categoryTabClicked(text)
    }

    function expandTab(tabName) {
        if(checked){
            settingDefinitionsModel.expandTab(definition.key)
        }
    }
}
