import QtQuick 2.4
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtQuick.Layouts 1.1

import "../singletons"
import "../tweaks"

CustomSlider {
    id: slider

    property bool deactivate: false

    orientation: Qt.Horizontal

    MouseArea {
        anchors.fill: parent
        visible: deactivate
    }

    style: SliderStyle {
        groove: Rectangle {
            implicitWidth: layout.width
            implicitHeight: 1
            color: Colors.sliderGroove

            Rectangle {
                anchors.fill: parent
                visible: deactivate
                color: Colors.buttonDeactivator
            }
        }

        handle: Rectangle {
            color: Colors.sliderHandle
            implicitWidth: Math.floor(Globals.fontPixelSize * 1.7)
            implicitHeight: width

            Rectangle {
                id: deactivateHandle
                anchors.fill: parent
                visible: deactivate
                color: Colors.buttonDeactivator
            }

            Text {
                text: "="
                font.pixelSize: Globals.fontPixelSize
                font.family: Fonts.boxed
                font.weight: Font.Black
                color: deactivate ? Colors.spinBoxButtonText : Colors.sliderLLColor
                anchors.centerIn: parent
                rotation: -90
            }
        }
    }
}