[shaders]
vertex =
    uniform highp mat4 u_modelViewProjectionMatrix;

    attribute highp vec4 a_vertex;
    attribute lowp vec2 a_uvs;

    varying lowp vec2 v_uvs;


    void main()
    {
        gl_Position = u_modelViewProjectionMatrix * a_vertex;
        v_uvs = a_uvs;
    }

fragment =
    uniform lowp vec4 u_gridColor0;
    uniform lowp vec4 u_gridColor1;
    uniform lowp vec2 u_fieldSize;

    uniform sampler2D u_texture;

    varying lowp vec2 v_uvs;

    void main()
    {


        mediump vec4 final_color = vec4(0.0);

        final_color = vec4(gl_FragCoord.x/2000.0,0.5,0.5,0.7);
        gl_FragColor=final_color;

    }

[defaults]
u_gridColor0 = [0.96, 0.96, 0.96, 1.0]
u_gridColor1 = [0.8, 0.8, 0.8, 1.0]

[bindings]
u_modelViewProjectionMatrix = model_view_projection_matrix

[attributes]
a_vertex = vertex
a_uvs = uv0
